#pragma once

#include "ofMain.h"
#include "FFT.h"
#include "ofxGui.h"

#define BUFSIZE 512        // must be 2^x
#define MODE_RECOGNIZER 1  // 認識モード
#define MODE_LEARNER 2     // 学習モード
#define MODE_READY 3       // 待機モード

class ofApp : public ofBaseApp{
    
public:
    void setup();
    void update();
    void draw();
    void keyPressed(int key);
    void keyReleased(int key);
    
    int recognizer(); // 戻り値によって，入力結果を教えてくれる
    void audioIn(float *input, int bufferSize, int nChannels);
    ofSoundStream soundStream;
    vector<float>average_power;
    
    ofxPanel gui;
    ofParameter<float>threshold_power; // 閾値
    ofxFloatSlider threshold_k;
    float feature[4];
    
    fft		myfft;
    float sound[BUFSIZE];
    float magnitude[BUFSIZE];  // 振幅
    float phase[BUFSIZE];      //
    float power[BUFSIZE];      // 振幅×振幅
    float sum_power[BUFSIZE];
    
    
    int mode;
    unsigned long long time_mode_changed;
    bool flg_pause;
    
    vector<float>buf_recognizer;
    ofTrueTypeFont font;
    float alpha;
    string str_result;
};
